////////////////////////////////////////////////////////////////////////////////
///
///		Title		: NPhoto Thread Pool
///
///		Copyright (c) 2006, NHN Co., Ltd. ALL RIGHTS RESERVED
///
///		Team		: Desktop Service Development
///
////////////////////////////////////////////////////////////////////////////////
#pragma once

#include "NPError.h"

/**
@brief					{kr} ο thread pool Ѵ. {/kr}
@param dwSize			{kr} [in]  thread  {/kr}
@return					{kr}  thread pool handle {/kr}
*/
HANDLE __stdcall NPCreateThreadPool(DWORD dwSize);

/**
@brief					{kr} thread pool Ѵ. {/kr}
@param dwSize			{kr} [in]  thread pool handle {/kr}
@return					{kr} ϰ TRUE̸ Լ  Ǿ ǹѴ. {/kr}
*/
NPERRCODE __stdcall NPDeleteThreadPool(HANDLE hThreadPool);

/**
@brief					{kr}   function thread pool queuing Ѵ. {/kr}
@param hThreadPool		{kr} [in] function  thread pool handle {/kr}
@param pFunction		{kr} [in]  function {/kr}
@param pParam			{kr} [in] pFunction  Բ   {/kr}
@return					{kr} ϰ TRUE̸ thread pool  queuingǾ ǹѴ. {/kr}
*/
NPERRCODE __stdcall NPQueueWorkItem(HANDLE hThreadPool, LPTHREAD_START_ROUTINE pFunction, PVOID pParam);

/**
@brief					{kr}   function thread pool queuing Ѵ. {/kr}
@param hThreadPool		{kr} [in] function  thread pool handle {/kr}
@param pFunction		{kr} [in]  function {/kr}
@param dwErrorCode		{kr} [in] pFunction  Բ  ù°  {/kr}
@param dwNumberOfBytesTransfered
						{kr} [in] pFunction  Բ  ι°  {/kr}
@param pOverlapped		{kr} [in] pFunction  Բ  °  {/kr}

@return					{kr} ϰ TRUE̸ thread pool  queuingǾ ǹѴ. {/kr}
*/
NPERRCODE __stdcall NPQueueWorkItem(HANDLE hThreadPool, LPOVERLAPPED_COMPLETION_ROUTINE pFunction, DWORD dwErrorCode, DWORD dwNumberOfBytesTransfered, LPOVERLAPPED pOverlapped);

/**
@brief					{kr} thread pool I/O completion port file handle bindѴ. {/kr}
@param hThreadPool		{kr} [in] bind thread pool handle {/kr}
@param hHandle			{kr} [in] bind file handle {/kr}
@param pfnCompletionCallback
						{kr} [in] file request I/O ۾ Ϸ  ȣ callback function. \n
						(callback function  ڼ  MSDN FileIOCompletionRoutine ׸ ) {/kr}
@return					{kr} ϰ TRUE̸ thread pool  queuingǾ ǹѴ. {/kr}
@remarks				{kr} thread pool I/O completion port file handle bindѴ.\n
						bind file request I/O ۾ Ϸ  thread pool worker thread  ϵ 
						callback function ȣȴ. {/kr}
*/
NPERRCODE __stdcall NPBindCompletionCallback(HANDLE hThreadPool, HANDLE hHandle, LPOVERLAPPED_COMPLETION_ROUTINE pfnCompletionCallback);
